<template>
  <button
    v-on:click="openScan()"
    v-if="!isScanOpen"
    class="fixed bottom-5 bg-orange-book hover:bg-orange-book-hover text-white font-bold py-2 px-4 rounded inline-flex items-center"
  >
  <svg
      xmlns="http://www.w3.org/2000/svg"
      class="h-6 w-6"
      fill="none"
      viewBox="0 0 24 24"
      stroke="currentColor"
    >
      <path
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
        d="M12 4v1m6 11h2m-6 0h-2v4m0-11v3m0 0h.01M12 12h4.01M16 20h4M4 12h4m12 0h.01M5 8h2a1 1 0 001-1V5a1 1 0 00-1-1H5a1 1 0 00-1 1v2a1 1 0 001 1zm12 0h2a1 1 0 001-1V5a1 1 0 00-1-1h-2a1 1 0 00-1 1v2a1 1 0 001 1zM5 20h2a1 1 0 001-1v-2a1 1 0 00-1-1H5a1 1 0 00-1 1v2a1 1 0 001 1z"
      />
    </svg>
    <span>Scanner un livre</span>
  </button>
  <button
    v-on:click="endScan()"
    v-if="isScanOpen"
    class="fixed bottom-5 bg-orange-book hover:bg-orange-book-hover text-white font-bold py-2 px-4 rounded inline-flex items-center"
  >
    <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
      <path stroke-linecap="round" stroke-linejoin="round" d="M21 12a9 9 0 11-18 0 9 9 0 0118 0z" />
      <path stroke-linecap="round" stroke-linejoin="round" d="M9 10a1 1 0 011-1h4a1 1 0 011 1v4a1 1 0 01-1 1h-4a1 1 0 01-1-1v-4z" />
    </svg>
    <span>Arrêter de scanner</span>
  </button>
</template>
<script>
import { startScan, stopScan } from "./../services/scannerService";

export default {
  name: "ScanButton",
  data() {
    return {
      isScanOpen: false,
    }
  },
  methods: {
    async openScan() {
     this.isScanOpen = true;
     const isbn = await startScan();
    if(isbn === "web"){
      this.$emit("event-qr-web", { web: true });
    }else if(isbn) {
       await stopScan();
       this.$router.push({ name: "BookDetails", params: { isbnBook: isbn } });
     }
    },
    async endScan() {
      this.isScanOpen = false;
      await stopScan().catch(() => {

      this.$emit("event-qr-web", { web: false });
      });
     
    }
  },
  watch: {
    // eslint-disable-next-line no-unused-vars
    $route(to, from) {
      this.endScan();
    }
  }
};
</script>
